//+------------------------------------------------------------------+
//|                                               atr - walander.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Red

//
//
//
//
//

extern string _            = "parameters";
extern int    AtrDays      = 3;
extern string AtrFrom      = "08:00";
extern string AtrTo        = "13:00";
extern int    timeZone     = 0;
extern int    daysShift    = 0;

//
//
//
//
//

double atrBuffer[];
double hiLows[][3];
string st1,et1;
string fileName;
int    shiftInSeconds;
int    accountNo;
string accountBroker;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,atrBuffer);
      daysShift = MathMax(daysShift,0);         
         st1 = normalizeTime(AtrFrom);
         et1 = normalizeTime(AtrTo);
         shiftInSeconds = timeZone*3600;
   IndicatorShortName("atr ("+AtrDays+", from :"+st1+" to"+et1+" time zone : "+timeZone+" days shift : "+daysShift+")");         
   fileName=WindowExpertName();
   return(0);
}

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define aHi    0
#define aLo    1
#define noData 2

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,hlSize,i;

   if(_!="getBarNumbers")
   if(Period()>PERIOD_H4) return(0);
   if(counted_bars < 0)   return(-1);
   if(counted_bars > 0)   counted_bars--;
   
      if(_=="getBarNumbers") { atrBuffer[0] = MathMin(Bars-counted_bars,Bars-1); return(0); }
           
      //
      //
      //
      //
      //

      limit  = MathMax(Bars-counted_bars,MathMin(iCustom(NULL,PERIOD_D1,fileName,"getBarNumbers",0,0)*PERIOD_D1/Period(),Bars-1));
      hlSize = ArrayRange(hiLows,0);
            
      //
      //
      //
      //
      //
      
      if (accountNo != AccountNumber() || accountBroker != AccountCompany())
      {
         accountNo     = AccountNumber();
         accountBroker = AccountCompany();
                limit  = Bars-1;
                hlSize = 0;
      }
      
      //
      //
      //
      //
      //
      
      if (hlSize != iBars(NULL,PERIOD_D1))
      {
         int oldSize = hlSize;
             hlSize  = iBars(NULL,PERIOD_D1);
                ArrayResize(hiLows,hlSize);
                for (i=hlSize-1; i>oldSize; i--)
                {
                   hiLows[i][noData] = 1;
                   hiLows[i][aHi]    = -99999999999;
                   hiLows[i][aLo]    =  99999999999;
                }
      }

   //
   //
   //
   //
   //

   int dayCount =  0;
   int dayShift = -1;

      for(i = limit; i >= 0; i--)
      {
         atrBuffer[i] = atrBuffer[i+1];
         dayShift     = iBarShift(NULL,PERIOD_D1,Time[i]-shiftInSeconds);
      
            string   st = TimeToStr(Time[i],TIME_DATE);
            datetime ts = StrToTime(st+st1)-shiftInSeconds;
            datetime te = StrToTime(st+et1)-shiftInSeconds;
      
         //
         //
         //
         //
         //
      
         int r = hlSize-dayShift-1;
         if (Time[i] >= ts && Time[i] < te)
         {
            hiLows[r][aLo]    = MathMin(Low[i] ,hiLows[r][aLo]);
            hiLows[r][aHi]    = MathMax(High[i],hiLows[r][aHi]);
            hiLows[r][noData] = 0;
            dayCount++;
         }
      }
   if (dayCount == 0) { Print("Atr - No data collected"); return(0); }
   
   //
   //
   //
   //
   //

      ts = StrToTime(TimeToStr(Time[0],TIME_DATE)+st1)-shiftInSeconds;

      //
      //
      //
      //
      //
      
      for(i = limit; i >= 0; i--)
      {
         dayShift = iBarShift(NULL,PERIOD_D1,Time[i]-shiftInSeconds)+daysShift;

         if (dayShift==0 && (Time[0]-shiftInSeconds) < ts)
               r = hlSize-dayShift-2;
         else  r = hlSize-dayShift-1;

         //
         //
         //
         //
         //
      
         double sum     = 0;
         double days    = AtrDays;
         int    reached = dayShift;
            for (int k=0; k<days && reached<hlSize ; k++, reached++)
            {
               if (hiLows[r-k][noData]==1)
               {
                  days++; continue;
               }
               sum += (hiLows[r-k][aHi]-hiLows[r-k][aLo]);
            }

         atrBuffer[i] = sum/AtrDays;
      }

   //
   //
   //
   //
   //

   return(0);      
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
      if (sepAt==-1) minute=0;

   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}